
;--------------------------------------------------------------------
;
;
;  DFS DECOMPRESS
;
;  (w) 26.10.1997 by Tim Bscke
;      31.10.1997 saved some extra bytes
;
;
;---------------------------------------------------------------------



maxcode=288

        section code,code

decrunch:
a
        lea     source(pc),a0   ;a0 = source
        lea     mem,a1          ;a1 = stats
        
        move.l  a1,a4   
        move.l  #maxcode+1,d7   ;d7 = range (later)
.lop1
        move.l  d7,(a4)+
        subq.w  #1,d7
        bpl.s   .lop1
        
        move.l  a4,a3           ;codestart

        addq.l  #1,d7           ;d7 = 0x10000 range
        move.w  (a0)+,d6        ;d6 = code
        moveq   #0,d5           ;d5 = bitcount
.bigloop
        move    #$0100,d1
        bsr.s   .getsymbol
        cmp     d1,d0
        beq.s   .ende
        bmi.s   .nolz77

        sub.w   d1,d0
        move    d0,a5           ;len
        bsr.s   .getsymbol
        cmp.w   d1,d0
        bmi.s   .noove8 
        move    d0,d1
        bsr.s   .getsymbol      
.noove8
        lsl.w   #8,d1   
        move.b  d0,d1
        neg.w   d1
        lea     (a4,d1.w),a6
        move.l  a5,d1
.lzloop
        move.b  (a6)+,(a4)+
        dbf     d1,.lzloop
        
        bra.s   .bigloop
.nolz77
        move.b  d0,(a4)+
        bra.s   .bigloop
.ende   
        move.l  $4.w,a6
        jsr     -636(a6)
        lea     chip,a5
        jmp     (a3)

.getsymbol
        move.l  (a1),d4         ;stat0
        
        move    d6,d3
        mulu.w  d4,d3
        add.l   d4,d3
        subq.l  #1,d3
        divu.l  d7,d3   ;d3=count
        
        move.l  a1,a2
        moveq   #-1,d0  ;decoded symbol
.statlop2
        cmp.l   (a2),d3
        bpl.s   .break
        addq.l  #1,(a2)+
        addq.l  #1,d0
        bra.s   .statlop2
.break
        move.l  (a2),d3
        mulu.l  d7,d3
        divu.l  d4,d3
        sub.w   d3,d6
        move.l  -(a2),d2
        subq.l  #1,d2
        mulu.l  d2,d7
        divu.l  d4,d7
        sub.l   d3,d7

          ;  while (range<=Half) {
          ;       range<<=1;
          ;       code<<=1;
          ;       code+=nextbit(in,bitindex++);
          ;   } //end bitin
.bitin
        bfextu  (a0){d5:1},d3
        addq.l  #1,d5
        add.w   d6,d6
        add.l   d7,d7
        or.w    d3,d6
        cmp.w   #$8001,d7
        bmi.s   .bitin
        rts
b
        printt "current depacker length:"
        printv b-a
        printt "full length:"
        printv c-a
source
        incdir  dh1:p_dawn2/bonsai/
        incbin  dawn2.dfs
c
        section data,bss
mem:
        ds.b    1024*1024
        section datac,bss_c
chip:
        ds.b    1024*256
